var $ = jQuery;
$(function() { 
	// Проверка на число, причем NaN не помеха
	function isNum(v) {
			return typeof v === 'number' && isFinite(v);
	} 

	// Шаблон мероприятия
	function GetSubModuleTmp(){
		return '\
		<div class="subModule">\
			<div class="name">\
				<input type="text" class="inputName" value="Наименование мероприятия">\
			</div>\
			<div class="currentControl"><input type="text" class="inputCredit inputCurrentControl" value=""></div>\
			<div class="landmarkControl"><input type="text" class="inputCredit inputLandmarkControl" value=""></div>\
			<div class="actions">\
				<div class="deleteSubModule delete"></div>\
				<div class="downSubModule down"></div>\
				<div class="upSubModule up"></div>\
			</div>\
		</div>\
		';
	}
	
	// Шаблон модуля
	function GetModuleTmp() {
		return '\
		<div class="moduleGroup">\
			<div class="moduleHead">\
				<div class="name">\
					<input type="text" class="inputName" value="Наименование модуля">\
				</div>\
				<div class="currentControl">0</div>\
				<div class="landmarkControl">0</div>\
				<div class="actions">\
					<div class="deleteModule delete"></div>\
					<div class="downModule down"></div>\
					<div class="upModule up"></div>\
					<div class="addSubModule add"></div>\
				</div>\
			</div>\
			<div class="subModules">\
			'+GetSubModuleTmp()+'\
			</div>\
		</div>'
	};
	
	// Подсчет текущего контроля
	function CountCurrentControl(subModulesDiv){
		var maxCredits = 0;
		$('.inputCurrentControl', subModulesDiv).each(function(){
			var credit = parseInt($(this).val());
			maxCredits = maxCredits + ((isNum(credit)) ? credit : 0);
		});
		subModulesDiv.prev().children('.currentControl').text(maxCredits);
	}
	// Подсчет рубежного контроля
	function CountLandmarkControl(subModulesDiv){
		var maxCredits = 0;
		$('.inputLandmarkControl', subModulesDiv).each(function(){
			var credit = parseInt($(this).val());
			maxCredits = maxCredits + ((isNum(credit)) ? credit : 0); 
		});
		subModulesDiv.prev().children('.landmarkControl').text(maxCredits);
	}
	
	// Переместить вверх МОДУЛЬ
    $(".moduleList").on('click', '.upModule', function(){
        var parentdiv = $(this).parent('div').parent('div').parent('div');
        parentdiv.insertBefore(parentdiv.prev());
        return false
    });
	
	// Переместить вниз МОДУЛЬ
    $(".moduleList").on('click', '.downModule', function(){
        var parentdiv = $(this).parent('div').parent('div').parent('div');
        parentdiv.insertAfter(parentdiv.next());
        return false
    });
	
	// Переместить вверх мероприятие
    $(".moduleList").on('click', '.upSubModule', function(){
        var parentdiv = $(this).parent('div').parent('div');
        parentdiv.insertBefore(parentdiv.prev());
        return false
    });
	
	// Переместить вниз мероприятие
    $(".moduleList").on('click', '.downSubModule', function(){
        var parentdiv = $(this).parent('div').parent('div');
        parentdiv.insertAfter(parentdiv.next());
        return false
    });
	
	// Добавить новый элемент в конец
	$('.addModule').click(function(){
		$('.moduleList').append(GetModuleTmp());
	});
	
	// Добавить мероприятие
	$('.moduleList').on('click', '.addSubModule', function(){
		$(this).parent().parent().next().append(GetSubModuleTmp());
	});
	
	// Удалить модуль
	$('.moduleList').on('click', '.deleteModule', function(){
		$(this).parent('div').parent('div').parent('div').remove();
	});
	
	// Удалить мероприятие
	$('.moduleList').on('click', '.deleteSubModule', function(){
		var subModulesDiv = $(this).parent().parent().parent();
		$(this).parent('div').parent('div').remove();
		CountCurrentControl(subModulesDiv);
		CountLandmarkControl(subModulesDiv);
	});
	
	// При записи в input текущий контроль
	// При фокусе
	$('.moduleList').on('focusin', '.inputCurrentControl', function(){
		//alert('Фокус');
	});
	// При потери фокуса
	$('.moduleList').on('focusout', '.inputCurrentControl', function(){
		var subModulesDiv = $(this).parent().parent().parent();
		CountCurrentControl(subModulesDiv);
		if (parseInt($(this).val()) > 0 )
			// Блокируем рубежный контроль
			$(this).parent().parent().children('.landmarkControl').children('.inputLandmarkControl').attr('readonly', true);
		else 
			$(this).parent().parent().children('.landmarkControl').children('.inputLandmarkControl').attr('readonly', false);
	});
	
	// При записи в input рубежный контроль
	// При фокусе
	$('.moduleList').on('focusin', '.inputLandmarkControl', function(){
		//alert('Фокус');
	});
	// При потери фокуса
	$('.moduleList').on('focusout', '.inputLandmarkControl', function(){
		var subModulesDiv = $(this).parent().parent().parent();
		CountLandmarkControl(subModulesDiv);
		if (parseInt($(this).val()) > 0 )
			// Блокируем рубежный контроль
			$(this).parent().parent().children('.currentControl').children('.inputCurrentControl').attr('readonly', true);
		else 
			$(this).parent().parent().children('.currentControl').children('.inputCurrentControl').attr('readonly', false);
	});
	
	// В inputCredit (где баллы вводить) разрешаем вводить только цифры
	$(".moduleList").on('keydown', '.inputCredit', function(event) {
        // Разрешаем: backspace, delete, tab и escape
        if ( event.keyCode == 46 || event.keyCode == 8 || event.keyCode == 9 || event.keyCode == 27 || 
             // Разрешаем: Ctrl+A
            (event.keyCode == 65 && event.ctrlKey === true) || 
             // Разрешаем: home, end, влево, вправо
            (event.keyCode >= 35 && event.keyCode <= 39)) {
                 // Ничего не делаем
                 return;
        }
        else {
            // Убеждаемся, что это цифра, и останавливаем событие keypress
            if ((event.keyCode < 48 || event.keyCode > 57) && (event.keyCode < 96 || event.keyCode > 105 )) {
                event.preventDefault(); 
            }   
        }
    });
	
	// При нажатие кнопки 'сохранить' генерация JSON
	$('.createStudyMap').click(function(){
		var modulesCount = 0;
		// jsonModules - JSON данные, для отправки на сервер
		var jsonModules = "{";
		var amountModulesHead = $('.moduleGroup').size();
		$('.moduleGroup').each(function(i){
			modulesCount++;
			var subModulesCount = 0;
			jsonModules += '"'+i+'"'+':{';
			var jsonModule = '"moduleName":"'+$(this).children('.moduleHead').children('.name').children('.inputName').val()+'",';
			// jsonSubModules - мероприятия в JSON представление
			var jsonSubModules = '"subModules":{';
			var amountSubModules = $('.subModule', this).size();
			$('.subModule', this).each(function(i){
				subModulesCount++;
				var subModuleName = $(this).children('.name').children('.inputName').val();
				
				var rateControl; // Тип контроля
				if (parseInt($(this).children('.currentControl').children('.inputCurrentControl').val()) > 0)
					rateControl = '"maxRate" : "'+parseInt($(this).children('.currentControl').children('.inputCurrentControl').val())+'", "typeControl" : "CurrentControl"';
				if (parseInt($(this).children('.landmarkControl').children('.inputLandmarkControl').val()) > 0)
					rateControl = '"maxRate" : "'+parseInt($(this).children('.landmarkControl').children('.inputLandmarkControl').val())+'", "typeControl" : "LandmarkControl"';
				
				jsonSubModules += '"'+i+'":{"subModuleName":"'+subModuleName+'", '+rateControl+'}';
				jsonSubModules += (i + 1 == amountSubModules) ? '' : ',';
			});
			jsonSubModules += ', "subModulesCount" : "'+subModulesCount+'"}';
			jsonModules += jsonModule+jsonSubModules;
			jsonModules += (i + 1 == amountModulesHead) ? '}' : '},';
		});
		jsonModules += ', "modulesCount" : "'+modulesCount+'" }';
		console.log(JSON.stringify(jsonModules));
		
		$.post(
			'/~dev_rating/handler/map/AddMap',
			{"data" : jsonModules},
			function(data){
				alert(data);
			},
			'json'
		);
	});

	/*
	// При нажатие кнопки 'сохранить' генерация JSON
	$('.saveStudyMap').click(function(){
		// jsonModules - JSON данные, для отправки на сервер
		var jsonModules = "{";
		var amountModulesHead = $('.moduleGroup').size();
		$('.moduleGroup').each(function(i){
			jsonModules += '"'+i+'"'+':{';
			var jsonModule = '"moduleHead": {"moduleName":"'+$(this).children('.moduleHead').children('.name').children('.inputName').val()+'", "id":"id/hash here", "currentControl":"'+$(this).children('.moduleHead').children('.currentControl').text()+'", "landmarkControl":"'+$(this).children('.moduleHead').children('.landmarkControl').text()+'"},';
			// jsonSubModules - мероприятия в JSON представление
			var jsonSubModules = '"subModules":{';
			var amountSubModules = $('.subModule', this).size();
			$('.subModule', this).each(function(i){
				var subModuleName = $(this).children('.name').children('.inputName').val();
				jsonSubModules += '"'+i+'":{"subModuleName":"'+subModuleName+'","id":"id/hash here"}';
				jsonSubModules += (i + 1 == amountSubModules) ? '' : ',';
			});
			jsonSubModules += '}';
			jsonModules += jsonModule+jsonSubModules;
			jsonModules += (i + 1 == amountModulesHead) ? '}' : '},';
			//console.log(JSON.stringify('{'+jsonModule+jsonSubModules+'}'));
		});
		jsonModules += "}";
		console.log(JSON.stringify(jsonModules));
		
		$.post(
			'/~dev_rating/handler/map/AddMap',
			{"data" : jsonModules},
			function(data){
				alert(data);
			},
			'json'
		);
	});
	*/
});
